SUBROUTINE DENSUNESCO
USE STATE
IMPLICIT NONE
INTEGER I,J,K
!
! THIS SUBROUTINE COMPUTES (IN-SITU) DENSITY AFTER UNESCOS FORMULA AS GIVEN in GILL
!

DO K=1,KB-1
  DO J=j1,j2
    DO I=i1,i2

      RHO(I,J,K) = 999.842594 + 6.793952E-2*T(I,J,K)  &
     &        - 9.095290E-3*T(I,J,K)**2 + 1.001685E-4*T(I,J,K)**3  &
     &        - 1.120083E-6*T(I,J,K)**4 + 6.536332E-9*T(I,J,K)**5

      RHO(I,J,K) = RHO(I,J,K) + (0.824493 - 4.0899E-3*T(I,J,K) &
     &       + 7.6438E-5*T(I,J,K)**2 - 8.2467E-7*T(I,J,K)**3 &
     &       + 5.3875E-9*T(I,J,K)**4) * S(I,J,K) &
     &       + 4.8314E-4 * S(I,J,K)**2

      IF (S(I,J,K).GT.0.) THEN
        RHO(I,J,K) = RHO(I,J,K)  &
     &       + (-5.72466E-3 + 1.0227E-4*T(I,J,K) &
     &       - 1.6546E-6*T(I,J,K)**2) * S(I,J,K)**1.5 
      ENDIF

      RHO(I,J,K) = RHO(I,J,K) - 1000. - RHOAVER
      rho(i,j,k) = rho(i,j,k)*fsm(i,j)
    END DO
  END DO
END DO

CALL DUMP_STATE("densunesco")
END
