module divinterfaces
!
! without these interfaces the pointer association status may not
! cross the subroutine interface, and the update_ghost machinery
! sometimes fail. 
!  
  interface
     subroutine advect(fieldold,field,delfield,faver,icode)     
       real, pointer :: fieldold(:,:,:),field(:,:,:),delfield(:,:,:)
       real faver
       integer icode
     end subroutine advect
  end interface

  interface
     subroutine vertdiff(f,wfsurf)
       real, pointer :: f(:,:,:), wfsurf(:,:), tmp3d(:,:,:)
     end subroutine vertdiff
  end interface
  
  interface
     subroutine upstreamq(qfield)
       real, pointer :: qfield(:,:,:)
     end subroutine upstreamq
  end interface

  interface
     subroutine shapiro(nfilter, f, is,ie, js,je, kdim)
       integer nfilter
       real, pointer :: f(:,:)
       integer is,ie,js,je,kdim
     end subroutine shapiro
  end interface
  
end module divinterfaces
