! join files line by line "horizontally":
! usage
!   ifort join.f90 -o join
!   ./join FILE1 FILE2 ... FILEN
!    
  integer n, err
  character(200) filename
  integer :: fileid=100, line
  
  n = command_argument_count()

  if(n <= 0) then
      write(*,*) "no files given. usage:"
      write(*,*) "  ./join FILE1 FILE2 ... FILEN  >  OUTFILE.DAT" 
      stop
  end if
  
  do i=1,n
      call get_command_argument(i, filename, status=err)
      open(fileid+i, file=filename, status="old", err=1)
  end do

  line = 0
  do
      line = line+1
      do i=1,n
          read(fileid+i,*,err=2,end=3) val1
          write(*,'(g14.7,1x)',advance="no") val1
      end do
      write(*,*)
  end do

3 stop
1 write(*,*) "could not open file=",trim(filename) ; stop
2 write(*,*) "error reading real from line ",line,"in file ", n ; stop
  
end
