SUBROUTINE SMAGOR
USE STATE
USE CONTROL_PARAMETERS, ONLY : CMSPONGE, AMSPONGE
IMPLICIT NONE
!
!   Local variables.
!
INTEGER I,J,K,DJ
REAL AMLIM,CMTMP
AMLIM = 0.5*0.0625*DX**2/DT
AM = 0.

DJ=1
IF(JM == 1) DJ=0

DO K = 1,KB-1
DO J=J_EQ_2,JM_MI_1
  DO I=I_EQ_2,IM_MI_1
    IF (FSM(I,J).GT.0.) THEN
        CMTMP = CM
        IF(CMSPONGE) CMTMP = SPONGE_CM(I,J)

        AM(I,J,K)=CMTMP*DX*DY*SQRT(((U(I+1,J,K)-U(I,J,K))/DX)**2 &
     &        +((V(I,J+DJ,K)-V(I,J,K))/DY)**2 &
     &     +.5*(.25*(U(I,J+DJ,K)+U(I+1,J+DJ,K)- &
     &U(I,J-DJ,K)-U(I+1,J-DJ,K))/DY    &
     &     + .25*(V(I+1,J,K)+V(I+1,J+DJ,K)- &
     &V(I-1,J,K)-V(I-1,J+DJ,K))/DX)**2)
        IF(AMSPONGE) AM(I,J,K) = MAX(SPONGE_CM(I,J), AM(I,J,K))
        AM(I,J,K) = MAX(AM(I,J,K),AMMIN)
     ENDIF
   END DO
 END DO
END DO
IF (CM.GT.0.) THEN
  AH = (CH/CM)*AM
ELSE
  AH = 0.
ENDIF 

DO K = 1,KB-1
  DO J=J_EQ_2,JM_MI_1
    DO I=I_EQ_2,IM_MI_1
      IF (FSM(I,J).GT.0.) THEN
        AM(I,J,K) = MIN(AM(I,J,K),AMLIM)
        AH(I,J,K) = MIN(AH(I,J,K),AMLIM)
      ENDIF
    END DO
  END DO
END DO

CALL DUMP_STATE("smagor")
END
